#ifndef MSP_INPUT_GAMECONTROLLER_H_
#define MSP_INPUT_GAMECONTROLLER_H_

#include <msp/io/eventdispatcher.h>
#include <msp/time/timedelta.h>
#include "device.h"

namespace Msp {
namespace Input {

class GameController: public Device
{
private:
	struct Private;

	Private *priv;
	IO::EventDispatcher *event_disp;

	static bool detect_done;
	static unsigned n_detected_controllers;

public:
	GameController(unsigned);
	virtual ~GameController();

	static unsigned detect();
	static bool is_available(unsigned = 0);

	void use_event_dispatcher(IO::EventDispatcher *);

	void tick();
	void tick(const Time::TimeDelta &);
};

} // namespace Input
} // namespace Msp

#endif
